module sha1_a0(clk, ivld, iidx, ival, ovld, oidx, we, wa, wd);
input clk;
input ivld;
input [9:0] iidx;
input ival;
output ovld;
output [9:0] oidx;
input we;
input [9:0] wa;
input [12:0] wd;

reg [12:0] ram [0:1023];
reg [12:0] ramrd;
reg ivalq;
reg ivldq;
always @(posedge clk) begin
    if(we)
	ram[wa] <= wd;
    ramrd <= ram[iidx];
    ivalq <= ival;
    ivldq <= ivld;
end

wire ovld = ivldq && ramrd[12] && ((ivalq == ramrd[10]) || !ramrd[11]);
wire [9:0] oidx = ramrd[11] ? ramrd[9:0] : (ramrd[9:0] + ivalq);

endmodule
