module sha1_a3(clk, ivld, iidx, ival, ovld, oidx, opass, we, wa, wd);
input clk;
input ivld;
input [9:0] iidx;
input [16:0] ival;
output ovld;
output [8:0] oidx;
output opass;
input we;
input [9:0] wa;
input [17:0] wd;

reg [17:0] ram [0:1023];
reg [17:0] ramrd;
reg [16:0] ivalq;
reg ivldq;
always @(posedge clk) begin
    if(we)
	ram[wa] <= wd;
    ramrd <= ram[iidx];
    ivalq <= ival;
    ivldq <= ivld;
end

wire opass = ivldq && ramrd[17] && (ramrd[16:0] == ivalq);
wire ovld = ivldq && !ramrd[17] && ramrd[16];
wire [8:0] oidx = {ramrd[8:3], ivalq[2:0]};

endmodule
