module sha1_a4(clk, ivld, iidx, ival, ipass, opass, we, wa, wd);
input clk;
input ivld;
input [8:0] iidx;
input [16:0] ival;
input ipass;
output opass;
input we;
input [8:0] wa;
input [29:0] wd;

reg [29:0] ram [0:511];
reg [29:0] ramrd;
reg [16:0] ivalq;
reg ivldq;
reg ipassq;
always @(posedge clk) begin
    if(we)
	ram[wa] <= wd;
    ramrd <= ram[iidx];
    ivalq <= ival;
    ivldq <= ivld;
    ipassq <= ipass;
end

wire match0 = ramrd[14] && (ramrd[13:0] == ivalq[16:3]);
wire match1 = ramrd[29] && (ramrd[28:15] == ivalq[16:3]);
wire opass = ipassq || (ivldq && (match0 || match1));

endmodule
