module sha1comp(clk, ivld, ival, opass, we, wa, wd);
input clk;
input ivld;
input [31:0] ival;
output opass;
input we;
input [12:0] wa;
input [17:0] wd;

reg [31:0] ivalq, ivalqq, ivalqqq, ivalqqqq;
always @(posedge clk) begin
    ivalq <= ival;
    ivalqq <= ivalq;
    ivalqqq <= ivalqq;
    ivalqqqq <= ivalqqq;
end

wire we0 = we && (wa[12:10]==3'b000);
wire vld1;
wire [9:0] idx1;
sha1_a0 a0 (clk, ivld, ival[9:0], ival[10], vld1, idx1, we0, wa[9:0], wd[12:0]);

wire we1 = we && (wa[12:10]==3'b001);
wire vld2;
wire [9:0] idx2;
sha1_a1a2 a1 (clk, vld1, idx1, ivalq[12:11], vld2, idx2, we1, wa[9:0], wd[13:0]);

wire we2 = we && (wa[12:10]==3'b010);
wire vld3;
wire [9:0] idx3;
sha1_a1a2 a2 (clk, vld2, idx2, ivalqq[14:13], vld3, idx3, we2, wa[9:0], wd[13:0]);

wire we3 = we && (wa[12:10]==3'b011);
wire vld4, pass4;
wire [8:0] idx4;
sha1_a3 a3 (clk, vld3, idx3, ivalqqq[31:15], vld4, idx4, pass4, we3, wa[9:0], wd[17:0]);

wire we4 = we && (wa[12:10]==3'b100);
wire we4l = we4 && !wa[0];
wire we4h = we4 && wa[0];
reg [11:0] a4_wdl;
always @(posedge clk)
	if(we4l)
		a4_wdl <= wd[11:0];
sha1_a4 a4 (clk, vld4, idx4, ivalqqqq[31:15], pass4, opass, we4h, wa[9:1], {wd, a4_wdl});

endmodule
