module sha1chip(clkp, clkn, r_we, r_re, r_ca, r_a, r_d, r_dv, irq, clkfw, clkfw2);
input clkp, clkn;
input r_we;
input r_re;
input [2:0] r_ca;
input [12:0] r_a;
inout [17:0] r_d;
output r_dv;
output irq;
output clkfw;
output clkfw2;

wire clk;
wire [7:0] dcm_status;
sha1 core (clk, r_we, r_re, r_ca, r_a, r_d, r_dv, irq, dcm_status);

wire clk_in;
core_dcm core_dcm_0 (
    .CLKIN_N_IN(clkn),
    .CLKIN_P_IN(clkp),
	 .CLKIN_IBUFGDS_OUT(clk_in),
    .CLKDV_OUT(clkfw),
    .CLKFX_OUT(clk),
    .STATUS_OUT(dcm_status[3:0])
);

clkfw_dcm clkfw_dcm_0 (
    .CLKIN_INT(clk_in),
    .CLKDV_OUT(clkfw2),
    .STATUS_OUT(dcm_status[7:4])
);

endmodule
